Loading...
Searching...
No Matches
elastix::TransformBase< TElastix > Class Template Referenceabstract
Components » Transforms | Core » Component Base Classes

`#include <elxTransformBase.h>`

## Detailed Description

template<class TElastix>
class elastix::TransformBase< TElastix >

This class is the elastix base class for all Transforms.

This class contains the common functionality for all Transforms.

The parameters used in this class are:

Parameters
  HowToCombineTransforms: Indicates how to use the initial transform
  (given by the command-line argument -t0, or, if using multiple parameter files, by the result of registration using the previous parameter file). Possible options are "Add" and "Compose".
  "Add" combines the initial transform and the current transform (which is currently optimized) by addition: ;
  "Compose" by composition: .
  example: (HowToCombineTransforms "Add")
  Default: "Add".

Transform Parameters

  UseDirectionCosines: Controls whether to use or ignore the direction cosines (world matrix, transform matrix) set in the images. Voxel spacing and image origin are always taken into account, regardless the setting of this parameter.
  example: (UseDirectionCosines "true")
  Default: true. Setting it to false means that you choose to ignore important information from the image, which relates voxel coordinates to world coordinates. Ignoring it may easily lead to left/right swaps for example, which could skrew up a (medical) analysis.

  HowToCombineTransforms: Indicates how to use the initial transform (given by the command-line argument -t0, or, if using multiple parameter files, by the result of registration using the previous parameter file). Possible options are "Add" and "Compose".
  "Add" combines the initial transform and the current transform (which is currently optimized) by addition: ;
  "Compose" by composition: .
  example: (HowToCombineTransforms "Add")
  Default: "Compose".

  Size: The size (number of voxels in each dimension) of the fixed image that was used during registration, and which is used for resampling the deformed moving image.
  example: (Size 100 90 90)
  Mandatory parameter.

  Index: The starting index of the fixed image region that was used during registration, and which is used for resampling the deformed moving image.
  example: (Index 0 0 0)
  Currently always zero.

  Spacing: The voxel spacing of the fixed image that was used during registration, and which is used for resampling the deformed moving image.
  example: (Spacing 1.0 1.0 1.0)
  Default: 1.0 for each dimension.

  Origin: The origin (location of the first voxel in world coordinate) of the fixed image that was used during registration, and which is used for resampling the deformed moving image.
  example: (Origin 5.0 10.0 11.0)
  Default: 0.0 for each dimension.

  Direction: The direction cosines matrix of the fixed image that was used during registration, and which is used for resampling the deformed moving image if the UseDirectionCosines parameter is set to "true".
  example: (Direction -1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.1)
  Default: identity matrix. Elements are sorted as follows: [ d11 d21 d31 d12 d22 d32 d13 d23 d33] (in 3D).

  TransformParameters: the transform parameter vector that defines the transformation.
  example (TransformParameters 0.03 1.0 0.2 ...)
  The number of entries is stored the NumberOfParameters entry.

  NumberOfParameters: the length of the transform parameter vector.
  example (NumberOfParameters 722)

  InitialTransformParameterFileName: The location/name of an initial transform that will be loaded when loading the current transform parameter file. Note that transform parameter file can also contain an initial transform. Recursively all transforms are thus automatically loaded when loading the last transform parameter file.
  example (InitialTransformParameterFileName "./res/TransformParameters.0.txt")
  The location is relative to the path from where elastix/transformix is started!
  Default: "NoInitialTransform", which (obviously) means that there is no initial transform to be loaded.

  InitialTransformParametersFileName: legacy parameter name, replaced with "InitialTransformParameterFileName", and deprecated from June 2023.

The command line arguments used by this class are:

Command line arguments

  -t0: optional argument for elastix for specifying an initial transform parameter file.
  example: -t0 TransformParameters.txt

  -def: optional argument for transformix for specifying a set of points that have to be transformed.
  example: -def inputPoints.txt
  The inputPoints.txt file should be structured: first line should be "index" or "point", depending if the user supplies voxel indices or real world coordinates. The second line should be the number of points that should be transformed. The third and following lines give the indices or points.
  It is also possible to deform all points, thereby generating a deformation field image. This is done by:
  example: -def all

Definition at line 137 of file elxTransformBase.h.

Inheritance diagram for elastix::TransformBase< TElastix >:
[legend]

## Public Types

using | CombinationTransformType = itk::AdvancedCombinationTransform<CoordRepType, Self::FixedImageDimension>
using | CommandLineArgumentMapType = Configuration ::CommandLineArgumentMapType
using | CommandLineEntryType = Configuration ::CommandLineEntryType
using | ComponentDescriptionType = ComponentDatabase::ComponentDescriptionType
using | CoordRepType = ElastixBase::CoordRepType
using | DeformationFieldImageType = itk::Image<VectorPixelType, FixedImageDimension>
using | FixedImageType = typename TElastix::FixedImageType
using | InitialTransformType = typename CombinationTransformType::InitialTransformType
using | InputPointType = typename ITKBaseType::InputPointType
using | ITKBaseType = CombinationTransformType
using | ITKRegistrationType = typename RegistrationType::ITKBaseType
using | MovingImageType = typename TElastix::MovingImageType
using | OptimizerType = typename ITKRegistrationType::OptimizerType
using | OutputPointType = typename ITKBaseType::OutputPointType
using | ParameterMapType = typename TElastix::ParameterMapType
using | ParametersType = itk::OptimizerParameters<ValueType>
using | PtrToCreator = ComponentDatabase::PtrToCreator
using | RegistrationType
using | ScalesType = itk::Optimizer::ScalesType
using | Self = TransformBase
using | SpatialJacobianDeterminantImageType = itk::Image<float, FixedImageDimension>
using | SpatialJacobianMatrixImageType
using | Superclass = BaseComponentSE<TElastix>
using | ValueType = double
using | VectorPixelType = itk::Vector<float, FixedImageDimension>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

int | BeforeAllTransformix ()
void | ComputeAndWriteSpatialJacobianDeterminantImage () const
void | ComputeAndWriteSpatialJacobianMatrixImage () const
SpatialJacobianDeterminantImageType::Pointer | ComputeSpatialJacobianDeterminantImage () const
SpatialJacobianMatrixImageType::Pointer | ComputeSpatialJacobianMatrixImage () const
void | CreateTransformParameterMap (const ParametersType &param, ParameterMapType &parameterMap, const bool includeDerivedTransformParameters=true) const
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (TransformBase)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual void | ReadFromFile ()
void | ReadInitialTransformFromFile (const std::string &transformParameterFileName)
void | SetFinalParameters ()
void | SetInitialTransform (InitialTransformType *_arg)
void | SetReadWriteTransformParameters (const bool _arg)
void | SetTransformParameterFileName (const std::string &filename)
template<typename TMesh>
TMesh::Pointer | TransformMesh (const TMesh &mesh) const
void | TransformPoints () const
void | WriteToFile (std::ostream &transformationParameterInfo, const ParametersType &param) const
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIteration ()
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolution ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistration ()
virtual int | BeforeAll ()
virtual void | BeforeEachResolution ()
virtual void | BeforeEachResolutionBase ()
virtual void | BeforeRegistration ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Protected Member Functions

void | AutomaticScalesEstimation (ScalesType &scales) const
void | AutomaticScalesEstimationStackTransform (const unsigned int numSubTransforms, ScalesType &scales) const
bool | HasITKTransformParameters () const
| TransformBase ()=default
| ~TransformBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Private Member Functions

void | AfterRegistrationBase () override
int | BeforeAllBase () override
void | BeforeRegistrationBase () override
template<typename TImage>
auto | CreateChangeInformationImageFilter (TImage *image) const
virtual ParameterMapType | CreateDerivedTransformParameterMap () const =0
template<template< typename, typename > class TSource, typename TOutputImage>
auto | CreateJacobianSource () const
| elxDeclarePureVirtualGetSelfMacro (ITKBaseType)
DeformationFieldImageType::Pointer | GenerateDeformationFieldImage () const
const InitialTransformType * | GetInitialTransform () const
std::string | GetInitialTransformParameterFileName () const
virtual const char * | GetTransformParameterFileName () const
void | ReadInitialTransformFromConfiguration (const Configuration::ConstPointer)
void | TransformPointsAllPoints () const
void | TransformPointsSomePoints (const std::string &filename) const
void | TransformPointsSomePointsVTK (const std::string &filename) const
void | WriteDeformationFieldImage (typename DeformationFieldImageType::Pointer) const
virtual void | WriteDerivedTransformDataToFile () const

## Private Attributes

ParametersType | m_FinalParameters
bool | m_ReadWriteTransformParameters { true }
std::string | m_TransformParameterFileName
ParametersType | m_TransformParameters

## Additional Inherited Members

Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Member Typedef Documentation

## CombinationTransformType

template<class TElastix>

using elastix::TransformBase< TElastix >::CombinationTransformType = itk::AdvancedCombinationTransform<CoordRepType, Self::FixedImageDimension>

Other typedef's.

Definition at line 171 of file elxTransformBase.h.

## CommandLineArgumentMapType

template<class TElastix>

using elastix::TransformBase< TElastix >::CommandLineArgumentMapType = Configuration ::CommandLineArgumentMapType

Definition at line 152 of file elxTransformBase.h.

## CommandLineEntryType

template<class TElastix>

using elastix::TransformBase< TElastix >::CommandLineEntryType = Configuration ::CommandLineEntryType

Definition at line 153 of file elxTransformBase.h.

## ComponentDescriptionType

template<class TElastix>

using elastix::TransformBase< TElastix >::ComponentDescriptionType = ComponentDatabase::ComponentDescriptionType

Typedef's from ComponentDatabase.

Definition at line 161 of file elxTransformBase.h.

## CoordRepType

template<class TElastix>

using elastix::TransformBase< TElastix >::CoordRepType = ElastixBase::CoordRepType

Elastix typedef's.

Definition at line 156 of file elxTransformBase.h.

## DeformationFieldImageType

template<class TElastix>

using elastix::TransformBase< TElastix >::DeformationFieldImageType = itk::Image<VectorPixelType, FixedImageDimension>

Definition at line 185 of file elxTransformBase.h.

## FixedImageType

template<class TElastix>

using elastix::TransformBase< TElastix >::FixedImageType = typename TElastix::FixedImageType

Definition at line 157 of file elxTransformBase.h.

## InitialTransformType

template<class TElastix>

using elastix::TransformBase< TElastix >::InitialTransformType = typename CombinationTransformType::InitialTransformType

Definition at line 173 of file elxTransformBase.h.

## InputPointType

template<class TElastix>

using elastix::TransformBase< TElastix >::InputPointType = typename ITKBaseType::InputPointType

Typedef's for TransformPoint.

Definition at line 180 of file elxTransformBase.h.

## ITKBaseType

template<class TElastix>

using elastix::TransformBase< TElastix >::ITKBaseType = CombinationTransformType

Definition at line 172 of file elxTransformBase.h.

## ITKRegistrationType

template<class TElastix>

using elastix::TransformBase< TElastix >::ITKRegistrationType = typename RegistrationType::ITKBaseType

Typedefs needed for AutomaticScalesEstimation function

Definition at line 188 of file elxTransformBase.h.

## MovingImageType

template<class TElastix>

using elastix::TransformBase< TElastix >::MovingImageType = typename TElastix::MovingImageType

Definition at line 158 of file elxTransformBase.h.

## OptimizerType

template<class TElastix>

using elastix::TransformBase< TElastix >::OptimizerType = typename ITKRegistrationType::OptimizerType

Definition at line 189 of file elxTransformBase.h.

## OutputPointType

template<class TElastix>

using elastix::TransformBase< TElastix >::OutputPointType = typename ITKBaseType::OutputPointType

Definition at line 181 of file elxTransformBase.h.

## ParameterMapType

template<class TElastix>

using elastix::TransformBase< TElastix >::ParameterMapType = typename TElastix::ParameterMapType

Typedef that is used in the elastix dll version.

Definition at line 199 of file elxTransformBase.h.

## ParametersType

template<class TElastix>

using elastix::TransformBase< TElastix >::ParametersType = itk::OptimizerParameters<ValueType>

Definition at line 177 of file elxTransformBase.h.

## PtrToCreator

template<class TElastix>

using elastix::TransformBase< TElastix >::PtrToCreator = ComponentDatabase::PtrToCreator

Definition at line 162 of file elxTransformBase.h.

## RegistrationType

template<class TElastix>

using elastix::BaseComponentSE< TElastix >::RegistrationType

RegistrationType; NB: this is the elx::RegistrationBase not an itk::Object or something like that.

Definition at line 62 of file elxBaseComponentSE.h.

## ScalesType

template<class TElastix>

using elastix::TransformBase< TElastix >::ScalesType = itk::Optimizer::ScalesType

Definition at line 190 of file elxTransformBase.h.

## Self

template<class TElastix>

using elastix::TransformBase< TElastix >::Self = TransformBase

Standard ITK stuff.

Definition at line 143 of file elxTransformBase.h.

## SpatialJacobianDeterminantImageType

template<class TElastix>

using elastix::TransformBase< TElastix >::SpatialJacobianDeterminantImageType = itk::Image<float, FixedImageDimension>

Typedefs for images of determinants of spatial Jacobian matrices, and images of spatial Jacobian matrices

Definition at line 193 of file elxTransformBase.h.

## SpatialJacobianMatrixImageType

template<class TElastix>

using elastix::TransformBase< TElastix >::SpatialJacobianMatrixImageType

Initial value:
itk::Image<itk::Matrix<float, MovingImageDimension, FixedImageDimension>, FixedImageDimension>

Definition at line 194 of file elxTransformBase.h.

## Superclass

template<class TElastix>

using elastix::TransformBase< TElastix >::Superclass = BaseComponentSE<TElastix>

Definition at line 144 of file elxTransformBase.h.

## ValueType

template<class TElastix>

using elastix::TransformBase< TElastix >::ValueType = double

Typedef's for parameters.

Definition at line 176 of file elxTransformBase.h.

## VectorPixelType

template<class TElastix>

using elastix::TransformBase< TElastix >::VectorPixelType = itk::Vector<float, FixedImageDimension>

Typedef's for TransformPointsAllPoints.

Definition at line 184 of file elxTransformBase.h.

## Constructor & Destructor Documentation

## TransformBase()

template<class TElastix>

elastix::TransformBase< TElastix >::TransformBase | ( |  | ) |

protected default

The default-constructor.

## ~TransformBase()

template<class TElastix>

elastix::TransformBase< TElastix >::~TransformBase | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## AfterRegistrationBase()

template<class TElastix>

void elastix::TransformBase< TElastix >::AfterRegistrationBase | ( |  | ) |

override private virtual

Execute stuff after the registration:

- Get and set the final parameters for the resampler.

Reimplemented from elastix::BaseComponent.

## AutomaticScalesEstimation()

template<class TElastix>

void elastix::TransformBase< TElastix >::AutomaticScalesEstimation | ( | ScalesType & | scales | ) | const

protected

Estimate a scales vector AutomaticScalesEstimation works like this:

- N=10000 points are sampled on a uniform grid on the fixed image.
- Jacobians dT/dmu are computed
- Scales_i = 1/N sum_x || dT / dmu_i ||^2

## AutomaticScalesEstimationStackTransform()

template<class TElastix>

void elastix::TransformBase< TElastix >::AutomaticScalesEstimationStackTransform | ( | const unsigned int | numSubTransforms,
|  | ScalesType & | scales ) const

protected

Estimate a scales vector for a stack transform (elxTranslationStackTransform, elxAffineStackTransform, ...) Instead of sampling along the n dimensions of the fixed image, it samples along n-1 dimensions. Then

- N=10000 points are sampled.
- Jacobians dT/dmu are computed
- Scales_i = 1/N sum_x || dT / dmu_i ||^2

## BeforeAllBase()

template<class TElastix>

int elastix::TransformBase< TElastix >::BeforeAllBase | ( |  | ) |

override private virtual

Execute stuff before everything else:

- Check the appearance of an initial transform.

Reimplemented from elastix::BaseComponent.

## BeforeAllTransformix()

template<class TElastix>

int elastix::TransformBase< TElastix >::BeforeAllTransformix | ( |  | ) |

Execute stuff before the actual transformation:

- Check the appearance of inputpoints to be transformed.

## BeforeRegistrationBase()

template<class TElastix>

void elastix::TransformBase< TElastix >::BeforeRegistrationBase | ( |  | ) |

override private virtual

Execute stuff before the actual registration:

- Set the initial transform and how to group transforms.

Reimplemented from elastix::BaseComponent.

## ComputeAndWriteSpatialJacobianDeterminantImage()

template<class TElastix>

void elastix::TransformBase< TElastix >::ComputeAndWriteSpatialJacobianDeterminantImage | ( |  | ) | const

Computes the determinant of the spatial Jacobian and writes it to file.

## ComputeAndWriteSpatialJacobianMatrixImage()

template<class TElastix>

void elastix::TransformBase< TElastix >::ComputeAndWriteSpatialJacobianMatrixImage | ( |  | ) | const

Computes the spatial Jacobian and writes it to file.

## ComputeSpatialJacobianDeterminantImage()

template<class TElastix>

SpatialJacobianDeterminantImageType::Pointer elastix::TransformBase< TElastix >::ComputeSpatialJacobianDeterminantImage | ( |  | ) | const

Computes the spatial Jacobian determinant for each pixel, and returns the image.

## ComputeSpatialJacobianMatrixImage()

template<class TElastix>

SpatialJacobianMatrixImageType::Pointer elastix::TransformBase< TElastix >::ComputeSpatialJacobianMatrixImage | ( |  | ) | const

Computes the spatial Jacobian matrix for each pixel, and returns the image.

## CreateChangeInformationImageFilter()

template<class TElastix>
template<typename TImage>

auto elastix::TransformBase< TElastix >::CreateChangeInformationImageFilter | ( | TImage * | image | ) | const

inline private

Creates an info changer that may change the direction of the image to the original value.

Definition at line 354 of file elxTransformBase.h.

## CreateDerivedTransformParameterMap()

template<class TElastix>

virtual ParameterMapType elastix::TransformBase< TElastix >::CreateDerivedTransformParameterMap | ( |  | ) | const

private pure virtual

Implemented in elastix::AdvancedAffineTransformElastix< TElastix >, elastix::AdvancedBSplineTransform< TElastix >, elastix::AffineDTITransformElastix< TElastix >, elastix::AffineLogStackTransform< TElastix >, elastix::AffineLogTransformElastix< TElastix >, elastix::BSplineStackTransform< TElastix >, elastix::BSplineTransformWithDiffusion< TElastix >, elastix::DeformationFieldTransform< TElastix >, elastix::EulerStackTransform< TElastix >, elastix::EulerTransformElastix< TElastix >, elastix::ExternalTransform< TElastix >, elastix::MultiBSplineTransformWithNormal< TElastix >, elastix::RecursiveBSplineTransform< TElastix >, elastix::SimilarityTransformElastix< TElastix >, elastix::SplineKernelTransform< TElastix >, elastix::TranslationStackTransform< TElastix >, elastix::TranslationTransformElastix< TElastix >, and elastix::WeightedCombinationTransformElastix< TElastix >.

## CreateJacobianSource()

template<class TElastix>
template<template< typename, typename > class TSource, typename TOutputImage>

auto elastix::TransformBase< TElastix >::CreateJacobianSource | ( |  | ) | const

inline private

Supports either TransformToDeterminantOfSpatialJacobianSource or TransformToSpatialJacobianSource as TSource.

Definition at line 330 of file elxTransformBase.h.

## CreateTransformParameterMap()

template<class TElastix>

void elastix::TransformBase< TElastix >::CreateTransformParameterMap | ( | const ParametersType & | param,
|  | ParameterMapType & | parameterMap,
|  | const bool | includeDerivedTransformParameters = true ) const

Function to create transform-parameters map.

## elxDeclarePureVirtualGetSelfMacro()

template<class TElastix>

elastix::TransformBase< TElastix >::elxDeclarePureVirtualGetSelfMacro | ( | ITKBaseType |  | ) |

private

## GenerateDeformationFieldImage()

template<class TElastix>

DeformationFieldImageType::Pointer elastix::TransformBase< TElastix >::GenerateDeformationFieldImage | ( |  | ) | const

private

Deprecation note: The plan is to split all Compute* and TransformPoints* functions into Generate* and Write* functions, since that would facilitate a proper library interface. To keep everything functional during the transition period we need to keep the orignal Compute* and TransformPoints* functions and let them just call Generate* and Write*. These functions should be considered marked deprecated. Function to transform all coordinates from fixed to moving image.

## GetAsITKBaseType() [1/2]

template<class TElastix>

ITKBaseType * elastix::TransformBase< TElastix >::GetAsITKBaseType | ( |  | ) |

inline

Retrieves this object as ITKBaseType.

Definition at line 203 of file elxTransformBase.h.

## GetAsITKBaseType() [2/2]

template<class TElastix>

const ITKBaseType * elastix::TransformBase< TElastix >::GetAsITKBaseType | ( |  | ) | const

inline

Retrieves this object as ITKBaseType, to use in const functions.

Definition at line 211 of file elxTransformBase.h.

## GetClassName()

template<class TElastix>

virtual const char * elastix::TransformBase< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::AdvancedAffineTransformElastix< TElastix >, elastix::AdvancedBSplineTransform< TElastix >, elastix::AffineDTITransformElastix< TElastix >, elastix::AffineLogStackTransform< TElastix >, elastix::AffineLogTransformElastix< TElastix >, elastix::BSplineStackTransform< TElastix >, elastix::BSplineTransformWithDiffusion< TElastix >, elastix::DeformationFieldTransform< TElastix >, elastix::EulerStackTransform< TElastix >, elastix::EulerTransformElastix< TElastix >, elastix::ExternalTransform< TElastix >, elastix::MultiBSplineTransformWithNormal< TElastix >, elastix::RecursiveBSplineTransform< TElastix >, elastix::SimilarityTransformElastix< TElastix >, elastix::SplineKernelTransform< TElastix >, elastix::TranslationStackTransform< TElastix >, elastix::TranslationTransformElastix< TElastix >, and elastix::WeightedCombinationTransformElastix< TElastix >.

## GetInitialTransform()

template<class TElastix>

const InitialTransformType * elastix::TransformBase< TElastix >::GetInitialTransform | ( |  | ) | const

private

Get the initial transform.

## GetInitialTransformParameterFileName()

template<class TElastix>

std::string elastix::TransformBase< TElastix >::GetInitialTransformParameterFileName | ( |  | ) | const

inline private

Definition at line 426 of file elxTransformBase.h.

## GetTransformParameterFileName()

template<class TElastix>

virtual const char * elastix::TransformBase< TElastix >::GetTransformParameterFileName | ( |  | ) | const

private virtual

Get the TransformParameterFileName.

## HasITKTransformParameters()

template<class TElastix>

bool elastix::TransformBase< TElastix >::HasITKTransformParameters | ( |  | ) | const

inline protected

Tells whether this transform is specified by TransformParameters from ITK

Definition at line 299 of file elxTransformBase.h.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::TransformBase< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | TransformBase< TElastix > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TElastix>

elastix::TransformBase< TElastix >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

Get the dimension of the fixed image.

## itkStaticConstMacro() [2/2]

template<class TElastix>

elastix::TransformBase< TElastix >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | MovingImageType::ImageDimension | )

Get the dimension of the moving image.

## ReadFromFile()

template<class TElastix>

virtual void elastix::TransformBase< TElastix >::ReadFromFile | ( |  | ) |

virtual

Function to read transform-parameters from a file.

Reimplemented in elastix::AdvancedAffineTransformElastix< TElastix >, elastix::AdvancedBSplineTransform< TElastix >, elastix::AffineDTITransformElastix< TElastix >, elastix::AffineLogStackTransform< TElastix >, elastix::AffineLogTransformElastix< TElastix >, elastix::BSplineStackTransform< TElastix >, elastix::BSplineTransformWithDiffusion< TElastix >, elastix::DeformationFieldTransform< TElastix >, elastix::EulerStackTransform< TElastix >, elastix::EulerTransformElastix< TElastix >, elastix::ExternalTransform< TElastix >, elastix::MultiBSplineTransformWithNormal< TElastix >, elastix::RecursiveBSplineTransform< TElastix >, elastix::SimilarityTransformElastix< TElastix >, elastix::SplineKernelTransform< TElastix >, elastix::TranslationStackTransform< TElastix >, and elastix::WeightedCombinationTransformElastix< TElastix >.

## ReadInitialTransformFromConfiguration()

template<class TElastix>

void elastix::TransformBase< TElastix >::ReadInitialTransformFromConfiguration | ( | const Configuration::ConstPointer |  | ) |

private

Function to read the initial transform parameters from the specified configuration object.

## ReadInitialTransformFromFile()

template<class TElastix>

void elastix::TransformBase< TElastix >::ReadInitialTransformFromFile | ( | const std::string & | transformParameterFileName | ) |

Function to read the initial transform parameters from a file.

## SetFinalParameters()

template<class TElastix>

void elastix::TransformBase< TElastix >::SetFinalParameters | ( |  | ) |

Makes sure that the final parameters from the registration components are copied, set, and stored.

## SetInitialTransform()

template<class TElastix>

void elastix::TransformBase< TElastix >::SetInitialTransform | ( | InitialTransformType * | _arg | ) |

Set the initial transform.

## SetReadWriteTransformParameters()

template<class TElastix>

void elastix::TransformBase< TElastix >::SetReadWriteTransformParameters | ( | const bool | _arg | ) |

Macro for reading and writing the transform parameters in WriteToFile or not.

## SetTransformParameterFileName()

template<class TElastix>

void elastix::TransformBase< TElastix >::SetTransformParameterFileName | ( | const std::string & | filename | ) |

Set the TransformParameterFileName.

## TransformMesh()

template<class TElastix>
template<typename TMesh>

TMesh::Pointer elastix::TransformBase< TElastix >::TransformMesh | ( | const TMesh & | mesh | ) | const

inline

Transforms the specified mesh.

Definition at line 282 of file elxTransformBase.h.

## TransformPoints()

template<class TElastix>

void elastix::TransformBase< TElastix >::TransformPoints | ( |  | ) | const

Function to transform coordinates from fixed to moving image.

## TransformPointsAllPoints()

template<class TElastix>

void elastix::TransformBase< TElastix >::TransformPointsAllPoints | ( |  | ) | const

private

Legacy function that calls GenerateDeformationFieldImage and WriteDeformationFieldImage.

## TransformPointsSomePoints()

template<class TElastix>

void elastix::TransformBase< TElastix >::TransformPointsSomePoints | ( | const std::string & | filename | ) | const

private

Function to transform coordinates from fixed to moving image.

## TransformPointsSomePointsVTK()

template<class TElastix>

void elastix::TransformBase< TElastix >::TransformPointsSomePointsVTK | ( | const std::string & | filename | ) | const

private

Function to transform coordinates from fixed to moving image, given as VTK file.

## WriteDeformationFieldImage()

template<class TElastix>

void elastix::TransformBase< TElastix >::WriteDeformationFieldImage | ( | typename DeformationFieldImageType::Pointer |  | ) | const

private

## WriteDerivedTransformDataToFile()

template<class TElastix>

virtual void elastix::TransformBase< TElastix >::WriteDerivedTransformDataToFile | ( |  | ) | const

inline private virtual

Allows a derived transform class to write its data to file, by overriding this member function.

Reimplemented in elastix::BSplineTransformWithDiffusion< TElastix >, and elastix::DeformationFieldTransform< TElastix >.

Definition at line 444 of file elxTransformBase.h.

## WriteToFile()

template<class TElastix>

void elastix::TransformBase< TElastix >::WriteToFile | ( | std::ostream & | transformationParameterInfo,
|  | const ParametersType & | param ) const

Function to write transform-parameters to a file.

## Field Documentation

## m_FinalParameters

template<class TElastix>

ParametersType elastix::TransformBase< TElastix >::m_FinalParameters

private

Definition at line 450 of file elxTransformBase.h.

## m_ReadWriteTransformParameters

template<class TElastix>

bool elastix::TransformBase< TElastix >::m_ReadWriteTransformParameters { true }

private

Boolean to decide whether or not the transform parameters are written.

Definition at line 453 of file elxTransformBase.h.

## m_TransformParameterFileName

template<class TElastix>

std::string elastix::TransformBase< TElastix >::m_TransformParameterFileName

private

Member variables.

Definition at line 448 of file elxTransformBase.h.

## m_TransformParameters

template<class TElastix>

ParametersType elastix::TransformBase< TElastix >::m_TransformParameters

private

Definition at line 449 of file elxTransformBase.h.

Generated on 1768596610 for elastix by 1.15.0 |